%define name	bind
%define ver	8.2.6
%define rel	3ml
%define serial	2002112001

Summary: An Internet name server.
Name: %{name}
Version: %{ver}
Release: %{rel}
Serial: %{serial}
Copyright: Distributable
Group: System Environment/Daemons

# You can get these source files from ftp://ftp.isc.org/isc/bind/src/%{version}/
Source0: bind-src.tar.gz
Source1: bind-doc.tar.gz
Source2: bind-contrib.tar.gz
Source3: named.init
Url: http://www.isc.org/bind.html
Patch0: bind-8.2.6-tl.patch
Patch1: bind-8.2.6-nonlist.patch
Patch2: bind-8.2.6-fds.patch
Patch3: bind-8.2.6-restart.patch
Patch4: http://www.isc.org/products/BIND/patches/bind826.diff
Buildroot: /var/tmp/bind-%{version}-root

Prereq: /sbin/chkconfig shadow-utils

%description
Bind includes the named name server, which resolves host names to IP
addresses (and vice versa), and a resolver library (a set of routines
in a system library that provide the interface for programs to use when
accessing domain name services).  A name server is a network service which
enables clients to name resources or objects and share this information
with other network machines.  The named name server can be used on
workstations as a caching name server, but is generally only needed on
one machine for an entire network.  Note that the configuration files for
making bind act as a simple caching nameserver are included in the
caching-nameserver package.  

Install the bind package if you need a name server for your network.  If
you want bind to act a caching name server, you will also need to install
the caching-nameserver package.

This package also includes the latest (post edition 3 of DNS & BIND)
edition of h2n, an essential tool for any BIND admin.


%package utils
Summary: DNS utilities:  host, dig, dnsquery, and nslookup.
Group: Applications/System


%description utils
Bind-utils contains a collection of utilities for querying DNS (Domain
Name Service) name servers to find out information about Internet
hosts.  These tools will provide you with the IP addresses for given
host names, as well as other information about registered domains and
network addresses.

You should install bind-utils if you need to get information from DNS
name servers.


%package devel
Summary: Include files and libraries needed for bind DNS development.
Group: Development/Libraries


%description devel
The bind-devel package contains all the include files and the 
library required for DNS (Domain Name Service) development
for bind versions 8.x.x.

You should install bind-devel if you want to develop bind DNS
applications. If you install bind-devel, you'll need to install
bind, as well.


%package contrib
Summary: tools and examples from various individual contributors.
Group: Applications/System
AutoReqProv: no


%description contrib
this directory is full of tools and examples that various individual
contributors have sent in.  most of them are actually in live
production use somewhere, though they are not of "publication" quality
which is why they are here instead of in comp.sources.unix.  most of
them are not documented other than with comments in the sources.  all
of them are fairly clever.

Note that the h2n here is old (version 2 vintage); the current h2n is
with the bind package.

%changelog
* Thu Nov 21 2002 Yuji Oishi <yoishi@miraclelinux.com>
- Added patch: http://www.isc.org/products/BIND/patches/bind826.diff
- Re-created bind-8.2.6-restart.patch to add verb_getargs()

* Mon Jun 01 2002 Yuji Oishi <yoishi@miraclelinux.com>
- Updated to version 8.2.6.
- change the path of h2n in original source.

* Wed Jun 13 2001 Janez Zupan <janez@turboloinux.com>
- added shadow-utils to PreReq

* Tue Jan 30 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- Updated to version 8.2.3.

* Fri Jan 19 2001 Masaru Yokoi  <masaru@turbolinux.co.jp>
- Fixed UID and GID of bind in 53.
- Removed StackGuard.

* Mon Nov 13 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- removed /usr/share/man/man3/resolver.3, resolver is provided by glibc.
- removed /usr/share/man/man3/getaddrinfo.3 .

* Mon Nov 13 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Updated to 8.2.2-P7. Previous version has a security vulnerability.

* Wed Oct 18 2000 Kiichiro Kyle Naka <knaka@turbolinux.co.jp>
- 8.2.2P5-5
- modified to start named with named.named user

* Fri Aug 18 2000 SL Baur  <steve@turbolinux.co.jp>
- no StackGuard on non-intel please
- debash, fix for rpm-4
- Synch with RedHat rawhide

* Mon Jun 12 2000 KC M<kcm@turbolinux.co.jp>
- start named by nobody.nobody

* Fri May 12 2000 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- rebuild with gcc SG

* Tue Mar 28 2000 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- rewrite %files section and %install section
- add serial

* Thu Nov 11 1999 KC M <kcm@turbolinux.co.jp>
- switch to 8.8.2 patchlevel 4

* Mon Nov  8 1999 KC M <kcm@turbolinux.co.jp>
- remove fds, glibc21 patches to build on TL4.x
- contrib/msql does not exist

* Sun Aug 15 1999 Nick Urbanik <nicku@vtc.edu.hk>
- Signed it.

* Fri Aug 13 1999 Nick Urbanik <nicku@vtc.edu.hk>
- Minor fix so can build in locations other than /usr/src/redhat.

* Thu Jul 08 1999 Nick Urbanik <nicku@vtc.edu.hk>
- bind-8.2.1
- Added the contrib as a package (marginally worthwhile)
- Added the current h2n (very worthwhile!)
- Added more documentation and included all the programs.

* Wed Mar 31 1999 Bill Nottingham <notting@redhat.com>
- add ISC patch
- add quick hack to make host not crash
- add more docs

* Fri Mar 26 1999 Cristian Gafton <gafton@redhat.com>
- add probing information in the init file to keep linuxconf happy
- dont strip libbind

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 3)

* Wed Mar 17 1999 Preston Brown <pbrown@redhat.com>
- removed 'done' output at named shutdown.

* Tue Mar 16 1999 Cristian Gafton <gafton@redhat.com>
- version 8.2

* Wed Dec 30 1998 Cristian Gafton <gafton@redhat.com>
- patch to use the __FDS_BITS macro
- build for glibc 2.1

* Wed Sep 23 1998 Jeff Johnson <jbj@redhat.com>
- change named.restart to /usr/sbin/ndc restart

* Sat Sep 19 1998 Jeff Johnson <jbj@redhat.com>
- install man pages correctly.
- change K10named to K45named.

* Wed Aug 12 1998 Jeff Johnson <jbj@redhat.com>
- don't start if /etc/named.conf doesn't exist.

* Sat Aug  8 1998 Jeff Johnson <jbj@redhat.com>
- autmagically create /etc/named.conf from /etc/named.boot in %post
- remove echo in %post

* Wed Jun 10 1998 Jeff Johnson <jbj@redhat.com>
- merge in 5.1 mods

* Sun Apr 12 1998 Manuel J. Galan <manolow@step.es>
- Several essential modifications to build and install correctly.
- Modified 'ndc' to avoid deprecated use of '-'

* Mon Dec 22 1997 Scott Lampert <fortunato@heavymetal.org>
- Used buildroot
- patched bin/named/ns_udp.c to use <libelf/nlist.h> for include
  on Redhat 5.0 instead of <nlist.h>


%prep


%setup -q -c -a 1 -a2

%patch0 -p1 -b .tl
%patch1 -p1 -b .nonlist
%patch2 -p1 -b .fds
%patch3 -p1 -b .restart
cd src
%patch4 -p0 -b .recursion
cd ..

rm -f compat/include/sys/cdefs.h

find src -name Makefile | xargs -n 1 perl -pi -e "s/^SYSTYPE=.*/SYSTYPE=linux/g"
find src -name Makefile | xargs -n 1 perl -pi -e "s/^SYSTYPE =.*/SYSTYPE=linux/g"
find src -name Makefile | xargs -n 1 perl -pi -e "s/^CDEBUG=.*/CDEBUG=$RPM_OPT_FLAGS/g"
find src -name Makefile | xargs -n 1 perl -pi -e "s/^CDEBUG =.*/CDEBUG=$RPM_OPT_FLAGS/g"

%build

make -C src
make clean all -C src SUBDIRS=../doc/man

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p ${RPM_BUILD_ROOT}/usr/bin
mkdir -p ${RPM_BUILD_ROOT}/usr/lib
mkdir -p ${RPM_BUILD_ROOT}/usr/sbin
mkdir -p ${RPM_BUILD_ROOT}/usr/share/man/man1
mkdir -p ${RPM_BUILD_ROOT}/usr/share/man/man3
mkdir -p ${RPM_BUILD_ROOT}/usr/share/man/man5
mkdir -p ${RPM_BUILD_ROOT}/usr/share/man/man7
mkdir -p ${RPM_BUILD_ROOT}/usr/share/man/man8
mkdir -p ${RPM_BUILD_ROOT}/usr/share/man/cat1
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/init.d
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc0.d
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc1.d
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc4.d
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc5.d
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc6.d
mkdir -p ${RPM_BUILD_ROOT}/var/named

make DESTDIR=$RPM_BUILD_ROOT install -C src INSTALL_LIB=""
make DESTDIR=$RPM_BUILD_ROOT install -C src SUBDIRS=../doc/man

# Install h2n:
install -m 755 contrib/nutshell/h2n ${RPM_BUILD_ROOT}/usr/bin/h2n
install -m 644 contrib/nutshell/h2n.1 ${RPM_BUILD_ROOT}/usr/share/man/man1/h2n.1

# Nick's Horrible kludge to avoid overwriting man pages from man-pages-1.23-3:
# Avoids confilicts.  Any better ideas?
mv -f ${RPM_BUILD_ROOT}/usr/share/man/man7/mailaddr.7 ${RPM_BUILD_ROOT}/usr/share/man/man7/mailaddr-bind.7 
mv -f ${RPM_BUILD_ROOT}/usr/share/man/man3/gethostbyname.3 ${RPM_BUILD_ROOT}/usr/share/man/man3/gethostbyname-bind.3
mv -f ${RPM_BUILD_ROOT}/usr/share/man/man5/resolver.5 ${RPM_BUILD_ROOT}/usr/share/man/man5/resolver-bind.5

install -m 755 $RPM_SOURCE_DIR/named.init ${RPM_BUILD_ROOT}/etc/rc.d/init.d/named

#strip things
strip $RPM_BUILD_ROOT/usr/bin/* || :
strip $RPM_BUILD_ROOT/usr/sbin/* || :

%post
groupadd -g 53 named 2> /dev/null || true;
useradd -u 53 -M -s "/bin/false" -g named -d /var/named named 2> /dev/null || true;
chown -R named.named /var/named

#/sbin/chkconfig --del named

#if [ -f /etc/named.boot -a ! -f /etc/named.conf ]; then
#  if [ -x /usr/doc/bind-%{version}/named-bootconf.pl ]; then
#    cat /etc/named.boot | /usr/doc/bind-%{version}/named-bootconf.pl > /etc/named.conf
#    chmod 644 /etc/named.conf
#  fi
#fi

%preun
if [ $1 = 0 ]
then
  /etc/rc.d/init.d/named stop
  /sbin/chkconfig --del named
fi

%postun
if [ $1 = 0 ]
then
  userdel named || true;
  groupdel named || true;
fi

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root)
%doc src/README src/INSTALL src/Version src/CHANGES src/TODO src/LICENSE_RSA src/SUPPORT
%doc doc/bog doc/html doc/misc doc/notes doc/old doc/rfc doc/tmac
%doc %attr(644,-,-) src/LICENSE

%config /etc/rc.d/init.d/named
/usr/sbin/named
/usr/sbin/named-xfer
/usr/sbin/ndc
/usr/bin/h2n
/usr/share/man/man5/named.conf.5*
/usr/share/man/man8/named.8*
/usr/share/man/man8/ndc.8*
/usr/share/man/man8/named-xfer.8*
/usr/share/man/man7/hostname.7*
/usr/share/man/man7/mailaddr-bind.7*
/usr/share/man/man1/h2n.1*
/var/named

%files utils
%defattr(-,root,root)
/usr/bin/nslookup
/usr/lib/nslookup.help
/usr/bin/host
/usr/bin/dig
/usr/bin/dnsquery
/usr/bin/addr
/usr/bin/nsupdate
/usr/bin/mkservdb
/usr/sbin/irpd
/usr/sbin/dnskeygen
/usr/sbin/named-bootconf
/usr/share/man/man1/dig.1*
/usr/share/man/man1/dnskeygen.1*
/usr/share/man/man1/host.1*
/usr/share/man/man1/dnsquery.1*
/usr/share/man/man5/resolver-bind.5*
/usr/share/man/man5/irs.conf.5*
/usr/share/man/man8/nslookup.8*
/usr/share/man/man8/named-bootconf.8*

%files devel
%defattr(-,root,root)
/usr/lib/bind
#/usr/share/man/man3/getaddrinfo.3*
/usr/share/man/man3/gethostbyname-bind.3*
/usr/share/man/man3/getnetent.3*
/usr/share/man/man3/hesiod.3*
/usr/share/man/man3/inet_cidr.3*
#/usr/share/man/man3/resolver.3*
/usr/share/man/man3/tsig.3*

%files contrib
%defattr(-,root,root)
%doc contrib/README
%doc contrib/adm
%doc contrib/arlib
%doc contrib/cider2named
%doc contrib/ckdns
%doc contrib/decwrl
%doc contrib/dns_signer
%doc contrib/dnsp
%doc contrib/dnsparse
%doc contrib/dnswalk
%doc contrib/doc
%doc contrib/getkeyby
%doc contrib/host
%doc contrib/hostmaint
%doc contrib/inaddrtool
%doc contrib/lamers
%doc contrib/manyhosts
%doc contrib/mdnkit
%doc contrib/misc
%doc contrib/multizdb
%doc contrib/named-lint
%doc contrib/netadm
%doc contrib/nextstep
%doc contrib/ninit
%doc contrib/nslint-2.0.2
%doc contrib/nutshell
%doc contrib/old
%doc contrib/os2-emx
%doc contrib/query-loc-0.0.1
%doc contrib/resparse-1.3
%doc contrib/rfc1101
%doc contrib/snoof
%doc contrib/sqlbind-8
%doc contrib/srv
%doc contrib/tplb
%doc contrib/trnamed
%doc contrib/ucsd
%doc contrib/umich
%doc contrib/updatehosts-1.1.0
%doc contrib/yaddas
%doc contrib/z0ne
%doc src/bin/named-bootconf/
